/*==================================================
Ce sketch est un scanner I2C: il essaye de communiquer
avec toutes les adresses I2C possibles et affiche
celle(s) qui réponde(nt).
  
                      BRANCHEMENT
* Pin SCD du moule à scanner  --->  SCD de l’Arduino
* Pin SDA du moule à scanner  --->  SDA de l’Arduino

// NE PAS OUBLIER LES 2 RESISTANCES ENTRE
SDA ET +5V ET ENTRE SLC ET +5V

http://bateaux.trucs.free.fr/scanneur_i2c.html

Le sketch est la copie de celui trouvé sur cette page
seul le texte a été traduit en français.

https://playground.arduino.cc/Main/I2cScanner/

==================================================== */
#include <Wire.h>

void setup()
{
  Wire.begin();
  Serial.begin(9600);
  Serial.println("\nI2C Scanner");
}

void loop()
{
  byte error, address;
  int nDevices;
  Serial.println("Recherche en cours...");
  nDevices = 0;
  for(address = 1; address < 127; address++ ) 
  {
    Wire.beginTransmission(address);
    error = Wire.endTransmission();

    if (error == 0)
    {
      Serial.print("Equiment I2C trouve a l'addresse 0x");
      if (address<16) 
        Serial.print("0");
      Serial.print(address,HEX);
      Serial.println("  !");
      nDevices++;
    }
    else if (error==4)
    {
      Serial.print("Erreur inconnue a l'address 0x");
      if (address<16) 
        Serial.print("0");
      Serial.println(address,HEX);
    }    
  }
  if (nDevices == 0)
    Serial.println("Aucun Equipement I2C trouve\n");
  else
    Serial.println("Fini\n");

  delay(5000);           
}
